Index: /mods/mod_amazon/PayWithAmazon/Client.php
===================================================================
--- /mods/mod_amazon/PayWithAmazon/Client.php	(revision 7755)
+++ /mods/mod_amazon/PayWithAmazon/Client.php	(revision 7756)
@@ -1301,25 +1618,24 @@
      * @optional requestParameters['mws_auth_token'] - [String]
      */
-
     public function reverseProviderCredit($requestParameters = array())
     {
-	$parameters           = array();
+        $parameters           = array();
         $parameters['Action'] = 'ReverseProviderCredit';
         $requestParameters    = array_change_key_case($requestParameters, CASE_LOWER);
 
         $fieldMappings = array(
-            'merchant_id' 		   => 'SellerId',
+            'merchant_id'                  => 'SellerId',
             'amazon_provider_credit_id'    => 'AmazonProviderCreditId',
-	    'credit_reversal_reference_id' => 'CreditReversalReferenceId',
-	    'credit_reversal_amount' 	   => 'CreditReversalAmount.Amount',
-	    'currency_code' 		   => 'CreditReversalAmount.CurrencyCode',
-	    'credit_reversal_note' 	   => 'CreditReversalNote',
-            'mws_auth_token' 		   => 'MWSAuthToken'
-        );
-
-        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
-
-        return ($responseObject);
-    }
+            'credit_reversal_reference_id' => 'CreditReversalReferenceId',
+            'credit_reversal_amount'       => 'CreditReversalAmount.Amount',
+            'currency_code'                => 'CreditReversalAmount.CurrencyCode',
+            'credit_reversal_note'         => 'CreditReversalNote',
+            'mws_auth_token'               => 'MWSAuthToken'
+        );
+
+        $responseObject = $this->setParametersAndPost($parameters, $fieldMappings, $requestParameters);
+        return ($responseObject);
+    }
+
 
     /* Create an Array of required parameters, sort them
@@ -1332,9 +1648,22 @@
      * @param Signature [String]
      */
-
     private function calculateSignatureAndParametersToString($parameters = array())
     {
+        foreach ($parameters as $key => $value) {
+            // Ensure that no unexpected type coercions have happened
+            if ($key === 'CaptureNow' || $key === 'ConfirmNow' || $key === 'InheritShippingAddress' || $key === 'RequestPaymentAuthorization') {
+                if (!is_bool($value)) {
+                    throw new \Exception($key . ' value ' . $value . ' is of type ' . gettype($value) . ' and should be a boolean value');
+                }
+            }
+
+            // Ensure boolean values are outputed as 'true' or 'false'
+            if (is_bool($value)) {
+                $parameters[$key] = json_encode($value);
+            }
+        }
+
         $parameters['AWSAccessKeyId']   = $this->config['access_key'];
-        $parameters['Version']          = self::SERVICE_VERSION;
+        $parameters['Version']          = self::MWS_VERSION;
         $parameters['SignatureMethod']  = 'HmacSHA256';
         $parameters['SignatureVersion'] = 2;
@@ -1347,8 +1676,10 @@
         $parameters              = $this->getParametersAsString($parameters);
 
-	// Save these parameters in the parameters variable so that it can be returned for unit testing.
-	$this->parameters 	 = $parameters;
+        // Save these parameters in the parameters variable so that it can be returned for unit testing.
+        $this->parameters = $parameters;
+
         return $parameters;
     }
+
 
     /* Computes RFC 2104-compliant HMAC signature for request parameters
@@ -1381,5 +1712,4 @@
      *
      */
-
     private function signParameters(array $parameters)
     {
@@ -1398,9 +1728,9 @@
     }
 
+
     /* Calculate String to Sign for SignatureVersion 2
      * @param array $parameters request parameters
      * @return String to Sign
      */
-
     private function calculateStringToSignV2(array $parameters)
     {
@@ -1412,9 +1742,12 @@
         $data .= "\n";
         $data .= $this->getParametersAsString($parameters);
+
+        $this->logMessage($this->sanitizeRequestData($data));
+
         return $data;
     }
 
+
     /* Convert paremeters to Url encoded query string */
-
     private function getParametersAsString(array $parameters)
     {
@@ -1425,5 +1758,7 @@
 
         return implode('&', $queryParameters);
-    }
+
+    }
+
 
     private function urlEncode($value)
@@ -1432,6 +1767,6 @@
     }
 
+
     /* Computes RFC 2104-compliant HMAC signature */
-
     private function sign($data, $algorithm)
     {
@@ -1447,10 +1782,11 @@
     }
 
+
     /* Formats date as ISO 8601 timestamp */
-
     private function getFormattedTimestamp()
     {
         return gmdate("Y-m-d\TH:i:s.\\0\\0\\0\\Z", time());
     }
+
 
     /* invokePost takes the parameters and invokes the httpPost function to POST the parameters
@@ -1458,5 +1794,4 @@
      * The response from the POST is an XML which is converted to Array
      */
-
     private function invokePost($parameters)
     {
@@ -1465,6 +1800,6 @@
         $this->success = false;
 
-    // Submit the request and read response body
-    try {
+        // Submit the request and read response body
+        try {
             $shouldRetry = true;
             $retries     = 0;
@@ -1472,11 +1807,9 @@
                 try {
                     $this->constructUserAgentHeader();
-
                     $httpCurlRequest = new HttpCurl($this->config);
                     $response = $httpCurlRequest->httpPost($this->mwsServiceUrl, $this->userAgent, $parameters);
                     $curlResponseInfo = $httpCurlRequest->getCurlResponseInfo();
-                    
                     $statusCode = $curlResponseInfo["http_code"];
-                    
+                    $this->logMessage($this->userAgent);
                     $response = array(
                         'Status' => $statusCode,
@@ -1485,11 +1818,10 @@
 
                     $statusCode = $response['Status'];
-                    
-            if ($statusCode == 200) {
+                    if ($statusCode == 200) {
                         $shouldRetry    = false;
                         $this->success = true;
                     } elseif ($statusCode == 500 || $statusCode == 503) {
 
-            $shouldRetry = true;
+                        $shouldRetry = true;
                         if ($shouldRetry && strtolower($this->config['handle_throttle'])) {
                             $this->pauseOnRetry(++$retries, $statusCode);
@@ -1506,16 +1838,23 @@
         }
 
+        $this->logMessage($this->sanitizeResponseData($response['ResponseBody']));
         return $response;
     }
 
+
     /* Exponential sleep on failed request
+     * Up to three retries will occur if first reqest fails
+     * after 1.0 second, 2.2 seconds, and finally 7.0 seconds
      * @param retries current retry
      * @throws Exception if maximum number of retries has been reached
      */
-
     private function pauseOnRetry($retries, $status)
     {
         if ($retries <= self::MAX_ERROR_RETRY) {
-            $delay = (int) (pow(4, $retries) * 100000);
+            // PHP delays are in microseconds (1 million microsecond = 1 sec)
+            // 1st delay is (4^1) * 100000 + 600000 = 0.4 + 0.6 second = 1.0 sec
+            // 2nd delay is (4^2) * 100000 + 600000 = 1.6 + 0.6 second = 2.2 sec
+            // 3rd delay is (4^3) * 100000 + 600000 = 6.4 + 0.6 second = 7.0 sec
+            $delay = (int) (pow(4, $retries) * 100000) + 600000;
             usleep($delay);
         } else {
@@ -1524,6 +1863,6 @@
     }
 
+
     /* Create MWS service URL and the Endpoint path */
-
     private function createServiceUrl()
     {
@@ -1533,7 +1872,13 @@
             $region = strtolower($this->config['region']);
             if (array_key_exists($region, $this->regionMappings)) {
-                $this->mwsEndpointUrl  = $this->mwsServiceUrls[$this->regionMappings[$region]];
-                $this->mwsServiceUrl   = 'https://' . $this->mwsEndpointUrl . '/' . $this->modePath . '/' . self::SERVICE_VERSION;
-                $this->mwsEndpointPath = '/' . $this->modePath . '/' . self::SERVICE_VERSION;
+
+                if (!is_null($this->config['override_service_url'])) {
+                    $this->mwsEndpointUrl  = preg_replace("(https?://)", "", $this->config['override_service_url']);
+                } else {
+                    $this->mwsEndpointUrl  = $this->mwsServiceUrls[$this->regionMappings[$region]];
+                }
+
+                $this->mwsServiceUrl   = 'https://' . $this->mwsEndpointUrl . '/' . $this->modePath . '/' . self::MWS_VERSION;
+                $this->mwsEndpointPath = '/' . $this->modePath . '/' . self::MWS_VERSION;
             } else {
                 throw new \Exception($region . ' is not a valid region');
@@ -1544,36 +1889,49 @@
     }
 
+
     /* Based on the config['region'] and config['sandbox'] values get the user profile URL */
-
     private function profileEndpointUrl()
     {
-	$profileEnvt = strtolower($this->config['sandbox']) ? "api.sandbox" : "api";
-	
+        $profileEnvt = strtolower($this->config['sandbox']) ? "api.sandbox" : "api";
+    
         if (!empty($this->config['region'])) {
             $region = strtolower($this->config['region']);
 
-	    if (array_key_exists($region, $this->regionMappings) ) {
+            if (array_key_exists($region, $this->regionMappings) ) {
                 $this->profileEndpoint = 'https://' . $profileEnvt . '.' . $this->profileEndpointUrls[$region];
-	    }else{
-		throw new \Exception($region . ' is not a valid region');
-	    }
-	} else {
+            } else {
+                throw new \Exception($region . ' is not a valid region');
+            }
+        } else {
             throw new \Exception("config['region'] is a required parameter and is not set");
         }
     }
 
+
     /* Create the User Agent Header sent with the POST request */
-
-    private function constructUserAgentHeader()
-    {
-        $this->userAgent = $this->quoteApplicationName($this->config['application_name']) . '/' . $this->quoteApplicationVersion($this->config['application_version']);
-        $this->userAgent .= ' (';
-        $this->userAgent .= 'Language=PHP/' . phpversion();
-        $this->userAgent .= '; ';
-        $this->userAgent .= 'Platform=' . php_uname('s') . '/' . php_uname('m') . '/' . php_uname('r');
-        $this->userAgent .= '; ';
-        $this->userAgent .= 'MWSClientVersion=' . self::MWS_CLIENT_VERSION;
+    /* Protected because of PSP module usaged */
+    protected function constructUserAgentHeader()
+    {
+        $this->userAgent = 'amazon-pay-sdk-php/' . self::SDK_VERSION . ' (';
+
+        if (($this->config['application_name']) || ($this->config['application_version'])) {
+            if ($this->config['application_name']) {
+                $this->userAgent .= $this->quoteApplicationName($this->config['application_name']);
+                if ($this->config['application_version']) {
+                    $this->userAgent .= '/';
+                }
+            }
+          
+            if ($this->config['application_version']) {
+                $this->userAgent .= $this->quoteApplicationVersion($this->config['application_version']);
+            }
+            $this->userAgent .= '; ';
+        }
+
+        $this->userAgent .= 'PHP/' . phpversion() . '; ';
+        $this->userAgent .= php_uname('s') . '/' . php_uname('m') . '/' . php_uname('r');
         $this->userAgent .= ')';
     }
+
 
     /* Collapse multiple whitespace characters into a single ' ' and backslash escape '\',
@@ -1582,5 +1940,4 @@
      * @return string
      */
-
     private function quoteApplicationName($s)
     {
@@ -1591,4 +1948,5 @@
     }
 
+
     /* Collapse multiple whitespace characters into a single ' ' and backslash escape '\',
      * and '(' characters from a string.
@@ -1597,5 +1955,4 @@
      * @return string
      */
-
     private function quoteApplicationVersion($s)
     {
@@ -1605,3 +1962,55 @@
         return $quotedString;
     }
+
+
+    private function sanitizeRequestData($input)
+    {
+        $patterns = array();
+        $patterns[0] = '/(SellerNote=)(.+)(&)/ms';
+        $patterns[1] = '/(SellerAuthorizationNote=)(.+)(&)/ms';
+        $patterns[2] = '/(SellerCaptureNote=)(.+)(&)/ms';
+        $patterns[3] = '/(SellerRefundNote=)(.+)(&)/ms';
+
+        $replacements = array();
+        $replacements[0] = '$1REMOVED$3';
+        $replacements[1] = '$1REMOVED$3';
+        $replacements[2] = '$1REMOVED$3';
+        $replacements[3] = '$1REMOVED$3';
+
+        return preg_replace($patterns, $replacements, $input);
+    }
+
+
+    private function sanitizeResponseData($input)
+    {
+        $patterns = array();
+        $patterns[0] = '/(<Buyer>)(.+)(<\/Buyer>)/ms';
+        $patterns[1] = '/(<PhysicalDestination>)(.+)(<\/PhysicalDestination>)/ms';
+        $patterns[2] = '/(<BillingAddress>)(.+)(<\/BillingAddress>)/ms';
+        $patterns[3] = '/(<SellerNote>)(.+)(<\/SellerNote>)/ms';
+        $patterns[4] = '/(<AuthorizationBillingAddress>)(.+)(<\/AuthorizationBillingAddress>)/ms';
+        $patterns[5] = '/(<SellerAuthorizationNote>)(.+)(<\/SellerAuthorizationNote>)/ms';
+        $patterns[6] = '/(<SellerCaptureNote>)(.+)(<\/SellerCaptureNote>)/ms';
+        $patterns[7] = '/(<SellerRefundNote>)(.+)(<\/SellerRefundNote>)/ms';
+
+        $replacements = array();
+        $replacements[0] = '$1 REMOVED $3';
+        $replacements[1] = '$1 REMOVED $3';
+        $replacements[2] = '$1 REMOVED $3';
+        $replacements[3] = '$1 REMOVED $3';
+        $replacements[4] = '$1 REMOVED $3';
+        $replacements[5] = '$1 REMOVED $3';
+        $replacements[6] = '$1 REMOVED $3';
+        $replacements[7] = '$1 REMOVED $3';
+
+        return preg_replace($patterns, $replacements, $input);
+    }
+
+
+    /* Computes RFC 2104-compliant HMAC signature */
+    public static function getSignature($stringToSign, $secretKey)
+    {
+        return base64_encode(hash_hmac('sha256', $stringToSign, $secretKey, true));
+    }
+
 }
Index: /mods/mod_amazon/PayWithAmazon/HttpCurl.php
===================================================================
--- /mods/mod_amazon/PayWithAmazon/HttpCurl.php	(revision 7755)
+++ /mods/mod_amazon/PayWithAmazon/HttpCurl.php	(revision 7756)
@@ -1,4 +1,4 @@
 <?php
-namespace PayWithAmazon;
+namespace AmazonPay;
 
 /* Class HttpCurl
@@ -6,5 +6,5 @@
  */
 
-require_once 'Interface.php';
+require_once 'HttpCurlInterface.php';
 
 class HttpCurl implements HttpCurlInterface
@@ -14,23 +14,24 @@
     private $accessToken = null;
     private $curlResponseInfo = null;
-    
+    private $headerArray = array();
+
     /* Takes user configuration array as input
      * Takes configuration for API call or IPN config
      */
-    
+
     public function __construct($config = null)
     {
         $this->config = $config;
     }
-    
+
     /* Setter for boolean header to get the user info */
-    
+
     public function setHttpHeader()
     {
         $this->header = true;
     }
-    
+
     /* Setter for Access token to get the user info */
-    
+
     public function setAccessToken($accesstoken)
     {
@@ -46,6 +47,6 @@
      * config['proxy_password']
      */
-    
-    private  function commonCurlParams($url,$userAgent)
+
+    protected function commonCurlParams($url,$userAgent)
     {
         $ch = curl_init();
@@ -55,23 +56,23 @@
         curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
         curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
-        
+
         if (!is_null($this->config['cabundle_file'])) {
             curl_setopt($ch, CURLOPT_CAINFO, $this->config['cabundle_file']);
         }
-        
+
         if (!empty($userAgent))
             curl_setopt($ch, CURLOPT_USERAGENT, $userAgent);
-        
+
         if ($this->config['proxy_host'] != null && $this->config['proxy_port'] != -1) {
             curl_setopt($ch, CURLOPT_PROXY, $this->config['proxy_host'] . ':' . $this->config['proxy_port']);
         }
-        
+
         if ($this->config['proxy_username'] != null && $this->config['proxy_password'] != null) {
             curl_setopt($ch, CURLOPT_PROXYUSERPWD, $this->config['proxy_username'] . ':' . $this->config['proxy_password']);
         }
-        
+
         return $ch;
     }
-    
+
     /* POST using curl for the following situations
      * 1. API calls
@@ -79,53 +80,50 @@
      * 3. Get User Info
      */
-    
+
     public function httpPost($url, $userAgent = null, $parameters = null)
     {
         $ch = $this->commonCurlParams($url,$userAgent);
-        
+      
         curl_setopt($ch, CURLOPT_POST, true);
         curl_setopt($ch, CURLOPT_POSTFIELDS, $parameters);
         curl_setopt($ch, CURLOPT_HEADER, false);
-        
         $response = $this->execute($ch);
         return $response;
     }
-    
+
     /* GET using curl for the following situations
      * 1. IPN certificate retrieval
      * 2. Get User Info
      */
-    
+
     public function httpGet($url, $userAgent = null)
     {
         $ch = $this->commonCurlParams($url,$userAgent);
-        
+
         // Setting the HTTP header with the Access Token only for Getting user info
         if ($this->header) {
-            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
-                'Authorization: bearer ' . $this->accessToken
-            ));
+            $this->headerArray[] = 'Authorization: bearer ' . $this->accessToken;
         }
-        
+
         $response = $this->execute($ch);
         return $response;
     }
-    
+
     /* Execute Curl request */
-    
-    private function execute($ch)
-	{
-		
-		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
-		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
-		
+    /* Protected because will be used by PSP module */
+    protected function execute($ch)
+    {
         $response = '';
+
+        // Ensure we never send the "Expect: 100-continue" header
+        $this->headerArray[] = 'Expect:';
+        curl_setopt($ch, CURLOPT_HTTPHEADER, $this->headerArray);
+
         $response = curl_exec($ch);
-        if (!$response = curl_exec($ch)) {
+        if ($response === false) {
             $error_msg = "Unable to post request, underlying exception of " . curl_error($ch);
             curl_close($ch);
             throw new \Exception($error_msg);
-        }
-        else{
+        } else {
             $this->curlResponseInfo = curl_getinfo($ch);
         }
@@ -133,7 +131,7 @@
         return $response;
     }
-    
+
     /* Get the output of Curl Getinfo */
-    
+
     public function getCurlResponseInfo()
     {
Index: /mods/mod_amazon/PayWithAmazon/IpnHandler.php
===================================================================
--- /mods/mod_amazon/PayWithAmazon/IpnHandler.php	(revision 7755)
+++ /mods/mod_amazon/PayWithAmazon/IpnHandler.php	(revision 7756)
@@ -1,4 +1,4 @@
 <?php
-namespace PayWithAmazon;
+namespace AmazonPay;
 
 /* Class IPN_Handler
@@ -8,6 +8,15 @@
 
 require_once 'HttpCurl.php';
-require_once 'Interface.php';
-class IpnHandler implements IpnHandlerInterface
+require_once 'IpnHandlerInterface.php';
+if (!interface_exists('\Psr\Log\LoggerAwareInterface')) {
+    require_once(__DIR__.'/../Psr/Log/LoggerAwareInterface.php');
+}
+if (!interface_exists('\Psr\Log\LoggerInterface')) {
+    require_once(__DIR__.'/../Psr/Log/LoggerInterface.php');
+}
+use Psr\Log\LoggerAwareInterface;
+use Psr\Log\LoggerInterface;
+
+class IpnHandler implements IpnHandlerInterface, LoggerAwareInterface
 {
 
@@ -19,10 +28,14 @@
     private $certificate = null;
     private $expectedCnName = 'sns.amazonaws.com';
+    private $defaultHostPattern = '/^sns\.[a-zA-Z0-9\-]{3,}\.amazonaws\.com(\.cn)?$/';
+
+    // Implement a logging library that utilizes the PSR 3 logger interface
+    private $logger = null;
 
     private $ipnConfig = array('cabundle_file'  => null,
-			       'proxy_host' 	=> null,
-                               'proxy_port' 	=> -1,
+                   'proxy_host'     => null,
+                               'proxy_port'     => -1,
                                'proxy_username' => null,
-			       'proxy_password' => null);
+                   'proxy_password' => null);
 
 
@@ -62,5 +75,5 @@
     {
         $ipnConfig = array_change_key_case($ipnConfig, CASE_LOWER);
-	$ipnConfig = $this->trimArray($ipnConfig);
+    $ipnConfig = $this->trimArray($ipnConfig);
 
         foreach ($ipnConfig as $key => $value) {
@@ -69,6 +82,18 @@
             } else {
                 throw new \Exception('Key ' . $key . ' is either not part of the configuration or has incorrect Key name.
-				check the ipnConfig array key names to match your key names of your config array ', 1);
+                check the ipnConfig array key names to match your key names of your config array ', 1);
             }
+        }
+    }
+
+    public function setLogger(LoggerInterface $logger = null) {
+        $this->logger = $logger;
+    }
+    
+    /* Helper function to log data within the Client */
+
+    private function logMessage($message) {
+        if ($this->logger) {
+            $this->logger->debug($message);
         }
     }
@@ -104,13 +129,14 @@
     private function trimArray($array)
     {
-	foreach ($array as $key => $value)
-	{
-	    $array[$key] = trim($value);
-	}
-	return $array;
+    foreach ($array as $key => $value)
+    {
+        $array[$key] = trim($value);
+    }
+    return $array;
     }
     
     private function validateHeaders()
     {
+
         // Quickly check that this is a sns message
         if (!array_key_exists('x-amz-sns-message-type', $this->headers)) {
@@ -203,5 +229,26 @@
              */
             $this->signatureFields = implode("\n", $signatureFields) . "\n";
-
+        }
+    }
+
+    /* Ensures that the URL of the certificate is one belonging to AWS.
+     *
+     * @param string $url Certificate URL
+     *
+     * @throws InvalidSnsMessageException if the cert url is invalid.
+     */
+
+    private function validateUrl($url)
+    {
+        $parsed = parse_url($url);
+        if (empty($parsed['scheme'])
+            || empty($parsed['host'])
+            || $parsed['scheme'] !== 'https'
+            || substr($url, -4) !== '.pem'
+            || !preg_match($this->defaultHostPattern, $parsed['host'])
+        ) {
+            throw new \Exception(
+                'The certificate is located on an invalid domain.'
+            );
         }
     }
@@ -210,5 +257,4 @@
      * public key
      *
-     * @param string $data            data to validate
      * @param string $signature       decoded signature to compare against
      * @param string $certificatePath path to certificate, can be file or url
@@ -221,7 +267,7 @@
     private function constructAndVerifySignature()
     {
-	$signature       = base64_decode($this->getMandatoryField("Signature"));
+    $signature       = base64_decode($this->getMandatoryField("Signature"));
         $certificatePath = $this->getMandatoryField("SigningCertURL");
-
+        $this->validateUrl($certificatePath);
         $this->certificate = $this->getCertificate($certificatePath);
 
@@ -241,5 +287,5 @@
         $httpCurlRequest  = new HttpCurl($this->ipnConfig);
 
-	$response = $httpCurlRequest->httpGet($certificatePath);
+    $response = $httpCurlRequest->httpGet($certificatePath);
 
         return $response;
@@ -248,5 +294,4 @@
     /* Verify that the signature is correct for the given data and public key
      *
-     * @param string $data            data to validate
      * @param string $signature       decoded signature to compare against
      * @param string $certificate     certificate object defined in Certificate.php
@@ -387,4 +432,7 @@
         $ipnMessage = $this->returnMessage();
 
+        $this->logMessage(sprintf('IPN received for merchant account: %s', $this->sanitizeResponseData($ipnMessage['SellerId'])));
+        $this->logMessage($this->sanitizeResponseData($ipnMessage['NotificationData']));
+
         // Getting the Simple XML element object of the IPN XML Response Body
         $response = simplexml_load_string((string) $ipnMessage['NotificationData']);
@@ -414,3 +462,23 @@
         return $remainingFields;
     }
+
+    private function sanitizeResponseData($input)
+    {
+
+        $patterns = array();
+        $patterns[0] = '/(<SellerNote>)(.+)(<\/SellerNote>)/ms';
+        $patterns[1] = '/(<AuthorizationBillingAddress>)(.+)(<\/AuthorizationBillingAddress>)/ms';
+        $patterns[2] = '/(<SellerAuthorizationNote>)(.+)(<\/SellerAuthorizationNote>)/ms';
+        $patterns[3] = '/(<SellerCaptureNote>)(.+)(<\/SellerCaptureNote>)/ms';
+        $patterns[4] = '/(<SellerRefundNote>)(.+)(<\/SellerRefundNote>)/ms';
+
+        $replacements = array();
+        $replacements[0] = '$1 REMOVED $3';
+        $replacements[1] = '$1 REMOVED $3';
+        $replacements[2] = '$1 REMOVED $3';
+        $replacements[3] = '$1 REMOVED $3';
+        $replacements[4] = '$1 REMOVED $3';
+
+        return preg_replace($patterns, $replacements, $input);
+    }
 }
Index: /mods/mod_amazon/PayWithAmazon/Regions.php
===================================================================
--- /mods/mod_amazon/PayWithAmazon/Regions.php	(revision 7755)
+++ /mods/mod_amazon/PayWithAmazon/Regions.php	(revision 7756)
@@ -1,4 +1,4 @@
 <?php
-namespace PayWithAmazon;
+namespace AmazonPay;
 
 /* Class Regions
Index: /mods/mod_amazon/PayWithAmazon/ResponseParser.php
===================================================================
--- /mods/mod_amazon/PayWithAmazon/ResponseParser.php	(revision 7755)
+++ /mods/mod_amazon/PayWithAmazon/ResponseParser.php	(revision 7756)
@@ -1,4 +1,4 @@
 <?php
-namespace PayWithAmazon;
+namespace AmazonPay;
 
 /* ResponseParser
@@ -6,5 +6,5 @@
  */
 
-require_once 'Interface.php';
+require_once 'ResponseInterface.php';
 
 class ResponseParser implements ResponseInterface
@@ -69,15 +69,7 @@
     public function getOrderReferenceDetailsStatus($response)
     {
-       $data= new \SimpleXMLElement($response);
-        $namespaces = $data->getNamespaces(true);
-        foreach($namespaces as $key=>$value){
-            $namespace = $value;
-        }
-        $data->registerXPathNamespace('GetORO', $namespace);
-        foreach ($data->xpath('//GetORO:OrderReferenceStatus') as $value) {
-            $oroStatus = json_decode(json_encode((array)$value), TRUE);
-        }
-        
-        return $oroStatus ;
+       $oroStatus = $this->getStatus('GetORO', '//GetORO:OrderReferenceStatus', $response);
+               
+       return $oroStatus;
     }
     
@@ -86,15 +78,22 @@
     public function getBillingAgreementDetailsStatus($response)
     {
+       $baStatus = $this->getStatus('GetBA', '//GetBA:BillingAgreementStatus', $response);  
+       
+       return $baStatus;
+    }
+    
+    private function getStatus($type, $path, $response) 
+    {
        $data= new \SimpleXMLElement($response);
-        $namespaces = $data->getNamespaces(true);
-        foreach($namespaces as $key=>$value){
-            $namespace = $value;
-        }
-        $data->registerXPathNamespace('GetBA', $namespace);
-        foreach ($data->xpath('//GetBA:BillingAgreementStatus') as $value) {
-            $baStatus = json_decode(json_encode((array)$value), TRUE);
-        }
-        
-        return $baStatus ;
+       $namespaces = $data->getNamespaces(true);
+       foreach($namespaces as $key=>$value){
+           $namespace = $value;
+       }
+       $data->registerXPathNamespace($type, $namespace);
+       foreach ($data->xpath($path) as $value) {
+           $status = json_decode(json_encode((array)$value), TRUE);
+       }
+       
+       return $status;
     }
 }
Index: /mods/mod_amazon/Psr/Log/AbstractLogger.php
===================================================================
--- /mods/mod_amazon/Psr/Log/AbstractLogger.php	(revision 7756)
+++ /mods/mod_amazon/Psr/Log/AbstractLogger.php	(revision 7756)
@@ -0,0 +1,128 @@
+<?php
+
+namespace Psr\Log;
+
+/**
+ * This is a simple Logger implementation that other Loggers can inherit from.
+ *
+ * It simply delegates all log-level-specific methods to the `log` method to
+ * reduce boilerplate code that a simple Logger that does the same thing with
+ * messages regardless of the error level has to implement.
+ */
+abstract class AbstractLogger implements LoggerInterface
+{
+    /**
+     * System is unusable.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function emergency($message, array $context = array())
+    {
+        $this->log(LogLevel::EMERGENCY, $message, $context);
+    }
+
+    /**
+     * Action must be taken immediately.
+     *
+     * Example: Entire website down, database unavailable, etc. This should
+     * trigger the SMS alerts and wake you up.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function alert($message, array $context = array())
+    {
+        $this->log(LogLevel::ALERT, $message, $context);
+    }
+
+    /**
+     * Critical conditions.
+     *
+     * Example: Application component unavailable, unexpected exception.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function critical($message, array $context = array())
+    {
+        $this->log(LogLevel::CRITICAL, $message, $context);
+    }
+
+    /**
+     * Runtime errors that do not require immediate action but should typically
+     * be logged and monitored.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function error($message, array $context = array())
+    {
+        $this->log(LogLevel::ERROR, $message, $context);
+    }
+
+    /**
+     * Exceptional occurrences that are not errors.
+     *
+     * Example: Use of deprecated APIs, poor use of an API, undesirable things
+     * that are not necessarily wrong.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function warning($message, array $context = array())
+    {
+        $this->log(LogLevel::WARNING, $message, $context);
+    }
+
+    /**
+     * Normal but significant events.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function notice($message, array $context = array())
+    {
+        $this->log(LogLevel::NOTICE, $message, $context);
+    }
+
+    /**
+     * Interesting events.
+     *
+     * Example: User logs in, SQL logs.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function info($message, array $context = array())
+    {
+        $this->log(LogLevel::INFO, $message, $context);
+    }
+
+    /**
+     * Detailed debug information.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function debug($message, array $context = array())
+    {
+        $this->log(LogLevel::DEBUG, $message, $context);
+    }
+}
Index: /mods/mod_amazon/Psr/Log/InvalidArgumentException.php
===================================================================
--- /mods/mod_amazon/Psr/Log/InvalidArgumentException.php	(revision 7756)
+++ /mods/mod_amazon/Psr/Log/InvalidArgumentException.php	(revision 7756)
@@ -0,0 +1,7 @@
+<?php
+
+namespace Psr\Log;
+
+class InvalidArgumentException extends \InvalidArgumentException
+{
+}
